# Class DualTreeBidiMap.BidiOrderedMapIterator<K,V>

java.lang.Object
org.apache.commons.collections4.bidimap.DualTreeBidiMap.BidiOrderedMapIterator<K,V>

Type Parameters:
  `K` - the type of the keys.
  `V` - the type of the values.

All Implemented Interfaces:
  `Iterator<K>`, `MapIterator<K,V>`, `OrderedIterator<K>`, `OrderedMapIterator<K,V>`, `ResettableIterator<K>`

Enclosing class:
  `DualTreeBidiMap<K,V>`

protected static class DualTreeBidiMap.BidiOrderedMapIterator<K,V> extends Object implements OrderedMapIterator<K,V>, ResettableIterator<K>
Inner class MapIterator.

Since:
  3.0

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `BidiOrderedMapIterator(AbstractDualBidiMap<K,V> parent)`
  Constructs a new instance.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `K`
  `getKey()`
  Gets the current key, which is the key returned by the last call to `next()`.
  `V`
  `getValue()`
  Gets the current value, which is the value associated with the last key returned by `next()`.
  `boolean`
  `hasNext()`
  Checks to see if there are more entries still to be iterated.
  `boolean`
  `hasPrevious()`
  Checks to see if there is a previous entry that can be iterated to.
  `K`
  `next()`
  Gets the next key from the `Map`.
  `K`
  `previous()`
  Gets the previous key from the `Map`.
  `void`
  `remove()`
  Removes the last returned key from the underlying `Map` (optional operation).
  `void`
  `reset()`
  Resets the iterator back to the position at which the iterator was created.
  `V`
  `setValue(V value)`
  Sets the value associated with the current key (optional operation).
  `String`
  `toString()`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.util.Iterator

  `forEachRemaining`

- ## Constructor Details

  - ### BidiOrderedMapIterator

    protected BidiOrderedMapIterator(AbstractDualBidiMap<K,V> parent)
    Constructs a new instance.
    Parameters:
      `parent` - the parent map

- ## Method Details

  - ### getKey

    public K getKey()
    Description copied from interface: `MapIterator`
    Gets the current key, which is the key returned by the last call to `next()`.
    Specified by:
      `getKey` in interface `MapIterator<K,V>`
    Returns:
      the current key

  - ### getValue

    public V getValue()
    Description copied from interface: `MapIterator`
    Gets the current value, which is the value associated with the last key returned by `next()`.
    Specified by:
      `getValue` in interface `MapIterator<K,V>`
    Returns:
      the current value

  - ### hasNext

    public boolean hasNext()
    Description copied from interface: `MapIterator`
    Checks to see if there are more entries still to be iterated.
    Specified by:
      `hasNext` in interface `Iterator<K>`
    Specified by:
      `hasNext` in interface `MapIterator<K,V>`
    Returns:
      `true` if the iterator has more elements

  - ### hasPrevious

    public boolean hasPrevious()
    Description copied from interface: `OrderedMapIterator`
    Checks to see if there is a previous entry that can be iterated to.
    Specified by:
      `hasPrevious` in interface `OrderedIterator<K>`
    Specified by:
      `hasPrevious` in interface `OrderedMapIterator<K,V>`
    Returns:
      `true` if the iterator has a previous element

  - ### next

    public K next()
    Description copied from interface: `MapIterator`
    Gets the next key from the `Map`.
    Specified by:
      `next` in interface `Iterator<K>`
    Specified by:
      `next` in interface `MapIterator<K,V>`
    Returns:
      the next key in the iteration

  - ### previous

    public K previous()
    Description copied from interface: `OrderedMapIterator`
    Gets the previous key from the `Map`.
    Specified by:
      `previous` in interface `OrderedIterator<K>`
    Specified by:
      `previous` in interface `OrderedMapIterator<K,V>`
    Returns:
      the previous key in the iteration

  - ### remove

    public void remove()
    Description copied from interface: `MapIterator`
    Removes the last returned key from the underlying `Map` (optional operation).

    This method can be called once per call to `next()`.

    Specified by:
      `remove` in interface `Iterator<K>`
    Specified by:
      `remove` in interface `MapIterator<K,V>`

  - ### reset

    public void reset()
    Description copied from interface: `ResettableIterator`
    Resets the iterator back to the position at which the iterator was created.
    Specified by:
      `reset` in interface `ResettableIterator<K>`

  - ### setValue

    public V setValue(V value)
    Description copied from interface: `MapIterator`
    Sets the value associated with the current key (optional operation).
    Specified by:
      `setValue` in interface `MapIterator<K,V>`
    Parameters:
      `value` - the new value
    Returns:
      the previous value

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`